/*C**************************************************************************
* O:			FixDuty.c
*----------------------------------------------------------------------------
* Copyright (c) 2004 Atmel.
*----------------------------------------------------------------------------
* J:			avr434_0_0_1
* :			1.1
*----------------------------------------------------------------------------
* ړI:
* ̧قPSCł̌Œޭèg`𐶐۸т񋟂܂B
****************************************************************************/

/* ߰E𽨯ɐڑĂB */
/* STK500XTAL1ެ߂苎ĂB */
/* ߰CLEDɐڑĂB */
/* g𑝂ɂSW1ĂB */
/* ޭè قςɂSW2ĂB */

/*_____ ݸٰ ___________________________________________________________*/
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"
#include "lib_mcu/pll/pll_drv.h"

/*F**************************************************************************
* O: PSC0
****************************************************************************/
void PSC0_Init (void)
{
  PSOC0 = (1<<POEN0A)|(1<<POEN0B);								// o0,o1

  PCNF0 = (0<<PMODE01)|(0<<PMODE00)|(1<<PCLKSEL0)|(1<<POP0);	/* PLLł1XΓ */

  PFRC0A = 0;
  PFRC0B = 0;

  PCTL0 = (1<<PRUN0);											/* s !! */
}

/*F**************************************************************************
* O: PSC0XV
*  ő = 4096
*  őޭè = 255
****************************************************************************/
void PSC0_Update (U16 period,U8 duty)
{
  U16 temp;

  PCNF0 = (1<<PLOCK0)|(0<<PMODE01)|(0<<PMODE00)|(1<<PCLKSEL0)|(1<<POP0);	// PLLł1XΓŊi[Jn

  temp = ((U32)period * duty) >> 8;											// 8ޯĐ
  OCR0RAH = HIGH(temp);														// ޭèlݒ(i[)
  OCR0RAL = LOW(temp);

  OCR0RBH = HIGH(period);													// lݒ(i[)
  OCR0RBL = LOW(period);
  PCNF0 = (0<<PLOCK0)|(0<<PMODE01)|(0<<PMODE00)|(1<<PCLKSEL0)|(1<<POP0);	// PLLł1XΓ(i[l)XV

}

/*F**************************************************************************
* O: main
****************************************************************************/
int main (void)
{
  U16 var_period = 4000;								// l
  U8 var_duty = 128;									// ޭèl

  Start_pll_32_mega();									// 32MHz PLL
  Wait_pll_ready();										// PLLҋ@
  PORTC = 0xFF;											// SLED
  DDRC = 0xFF;											// SLED߰ďo͐ݒ
  PSC0_Init();											// PSC0

  PSC0_Update (var_period,var_duty);					// PSC0ޭè
  while(1)
  {
    if (bit_is_clear(PINE,PINE1))						// SW1ŁA
    {
      while (bit_is_clear(PINE,PINE1));					// SW1Jҋ@
      var_period -= 40;									// l
      if (var_period < 100) var_period = 4000;			// zŏlɕύX
      PSC0_Update (var_period,var_duty);				// PSC0XV
    }

    if (bit_is_clear(PINE,PINE2))						// SW2ŁA
    {
      while (bit_is_clear(PINE,PINE2));					// SW2Jҋ@
      var_duty += 5;									// ޭèlis
      if (var_duty > 254) var_duty = 5;					// zŉlɕύX
      PSC0_Update (var_period,var_duty);				// PSC0ޭèύX
    }
; }
}
