/*C**************************************************************************
* O:			PscInputs.c
*----------------------------------------------------------------------------
* Copyright (c) 2004 Atmel.
*----------------------------------------------------------------------------
* J:			avr434_0_0_1
* :			1.1
*----------------------------------------------------------------------------
* ړI:
* ̧قPSCg`𐶐۸т񋟂܂B
****************************************************************************/

/* ߰E𽨯ɐڑĂB */
/* STK500XTAL1ެ߂苎ĂB */
/* ߰CLEDɐڑĂB */
/* SW1͌蓮I܂B */
/* SW2PSC~܂B */

/*_____ ݸٰ ___________________________________________________________*/
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"

#define DEAD_TIME_0		50
#define ON_TIME_0		75
#define DEAD_TIME_1		100
#define ON_TIME_1		125

#define E_N_RAMPS	4	/* E_N_RAMPS : PSC0XΔԍ4,2,1,0() */
#define E_FAULT_0A		/* E_RETRIG_0A : A͋ */
//#define E_FAULT_0B	/* E_RETRIG_0B : B͋ */

/*F**************************************************************************
* O: PSC0
****************************************************************************/
void PSC0_Init (unsigned char Fault_Number)
{
  PSOC0 = (1<<POEN0A)|(1<<POEN0B);								// o0,o1
  OCR0SAH = HIGH(DEAD_TIME_0);									// َ0ݒ
  OCR0SAL = LOW(DEAD_TIME_0);
  OCR0RAH = HIGH(ON_TIME_0);									// ON0ݒ
  OCR0RAL = LOW(ON_TIME_0);
  OCR0SBH = HIGH(DEAD_TIME_1);									// َ1ݒ
  OCR0SBL = LOW(DEAD_TIME_1);
  OCR0RBH = HIGH(ON_TIME_1);									// ON1ݒ
  OCR0RBL = LOW(ON_TIME_1);

#if (E_N_RAMPS == 4)
  PCNF0 = (1<<PMODE01)|(1<<POP0);								/* 4XΓ */
#else
#if (E_N_RAMPS == 2)
  PCNF0 = (1<<PMODE00)|(1<<POP0);								/* 2XΓ */
#else
#if (E_N_RAMPS == 1)
  PCNF0 = (0<<PMODE01)|(0<<PMODE00)|(1<<POP0);					/* 1XΓ */
#else
  PCNF0 = (1<<PMODE01)|(1<<PMODE00)|(1<<POP0);					/* 񓮍 */
#endif
#endif
#endif

#ifdef E_FAULT_0A
  PFRC0A = (1<<PELEV0A)|(1<<PFLTE0A)|(0<<PRFM0A3)|(Fault_Number&0x07);	// 苖,HL,hg틖,ԍ
#else
  PFRC0A = 0;
#endif

/* PSC0IN1͂I邽߂PISEL0Bݒ(1) */
#ifdef E_FAULT_0B
  PFRC0B = (0<<PISEL0B)|(1<<PELEV0B)|(1<<PFLTE0B)|(0<<PRFM0B3)|(Fault_Number&0x07);
#else
  PFRC0B = 0;
#endif

  PCTL0 = (1<<PRUN0);											/* s !! */
}

/*F**************************************************************************
* O: PSC0~
****************************************************************************/
void PSC0_Stop (void)
{
  PCTL0 = (0<<PRUN0);											/* ~ !! */
}

/*F**************************************************************************
* O: main
****************************************************************************/
int main (void)
{
  unsigned char Fault = 0;

  PSC0_Init(0);								// PSC0
  PORTD = (1<<PORTD1);						/* PSCIN0 ٱߋ */
  PORTC = 0xFF;								// SLED
  DDRC = 0xFF;								// SLED߰ďo͐ݒ
  while(1)
  {
    if (bit_is_clear(PINE,PINE1))			// SW1ŁA
    {
      while (bit_is_clear(PINE,PINE1));		// SW1Jҋ@
      Fault++;								// (PSC͓)ԍis
      Fault = Fault & 0x07;					// ԍ]ۂ
      PORTC = ~(Fault);						// ԍLEDo
      PSC0_Init (Fault);					// PSC͓(ԍ)ōď
    }

    if (bit_is_clear(PINE,PINE2))			// SW2ŁA
    {
      while (bit_is_clear(PINE,PINE2));		// SW2Jҋ@
      PSC0_Stop ();							// PSC~
    }
  }
}
